\documentclass{beamer}

\usepackage{tikz}

\usetikzlibrary{arrows, positioning}

\begin{document}

\begin{frame}
  \begin{tikzpicture}[
      filetype/.style={
        circle, draw,
      },
      edge/.style={
        ->, >=stealth',
        shorten >=1pt,
      }
    ]
    % Standard document pipeline
    \node[filetype] (tex) {.tex};
    \node[filetype, right=1cm of tex] (dvi) {\texttt{.dvi}};
    \node[filetype, right=1cm of dvi] (ps) {\texttt{.ps}};
    \node[filetype, right=1cm of ps] (pdf) {\texttt{.pdf}};
    \draw[edge] (tex) edge node[above] {\texttt{tex}} (dvi)
                (dvi) edge (ps)
                (ps) edge (pdf);
    % Web/weave/tangle
    \node[filetype, below=1cm of tex] (web) {\texttt{.web}};
    \node[filetype, right=1cm of web] (p) {\texttt{.p}};
    \node[filetype, right=1cm of p] (o) {\texttt{.o}};
    \draw[edge] (web) edge node[left] {\texttt{weave}} (tex)
                (web) edge node[above] {\texttt{tangle}} (p)
                (p) edge (o);
    % Fonts
    \node[filetype, above=1cm of tex] (mf) {\texttt{.mf}};
    \node[filetype, right=1cm of mf] (gf) {\texttt{.gf}};
    \node[filetype, above=1cm of gf] (pk) {\texttt{.pk}};
    \node[filetype, left=1cm of mf] (tfm) {\texttt{.tfm}};
    \node[filetype, above=1cm of tfm] (pl) {\texttt{.pl}};
    \draw[edge] (mf) edge node[left] {\texttt{mft}} (tex)
                (mf) edge node[above] {\texttt{mf}} (tfm)
                (mf) edge node[above] {\texttt{mf}} (gf)
                (tfm) edge[bend left=20] node[left] {\texttt{tfmtopl}} (pl)
                (pl) edge[bend left=20] node[right] {\texttt{pltotfm}} (tfm)
                (gf) edge[bend left=20] node[left] {\texttt{gftopk}} (pk)
                (pk) edge[bend left=20] node[right] {\texttt{pktogf}} (gf)
                (gf) edge node[left] {\texttt{gftodvi}} (dvi)
                ;
  \end{tikzpicture}
\end{frame}

\end{document}
% vim: ft=tex sw=2
